use strictures 1;
use Test::More;

use App::Clifton::ConfigLoader;

my $cl = App::Clifton::ConfigLoader->new;

my $conf = $cl->config_from_file('t/test.conf');

ok(
  my $h = $conf->bridges->get({ name => 'example' }),
  'example bridge exists'
);

is($h->jabber->server, 'example.org', 'property on bridge ok');

ok(
  my $u = $conf->users->get({ name => 'mst@example.org' }),
  'example user exists'
);

is_deeply($u->allow, [ 'example' ], 'property on user ok');

done_testing;
